define("io.ox/core/deputy/dialog",["io.ox/backbone/views/modal","io.ox/backbone/views/disposable","io.ox/backbone/mini-views","io.ox/participants/add","io.ox/core/folder/api","io.ox/contacts/util","io.ox/core/deputy/api","io.ox/core/api/user","gettext!io.ox/core","io.ox/core/yell","less!io.ox/core/deputy/style"],function(i,e,n,t,a,l,s,r,d,u){"use strict";var c={none:0,viewer:257,editor:33025,author:4227332},m={sendOnBehalfOf:!1,modulePermissions:{mail:{permission:c.viewer,folderIds:[a.getDefaultFolder("mail")]},calendar:{permission:c.viewer,folderIds:[a.getDefaultFolder("calendar")]}}},p={mail:d("Inbox"),calendar:d("Calendar")},f={0:d("None"),257:d("Viewer"),33025:d("Editor"),4227332:d("Author")};function v(o){var e={sendOnBehalfOf:o.get("sendOnBehalfOf"),modulePermissions:o.get("modulePermissions")},t=new i({title:d("Deputy: %1$s",l.getFullName(o.get("userData").attributes,!1))}).build(function(){var e=new Backbone.Model({permission:o.get("modulePermissions").calendar.permission}),t=new Backbone.Model({permission:o.get("modulePermissions").mail.permission});t.on("change:permission",function(e,t){var i=o.get("modulePermissions");i.mail.permission=t,o.set("modulePermissions",i)}),e.on("change:permission",function(e,t){var i=o.get("modulePermissions");i.calendar.permission=t,o.set("modulePermissions",i)}),this.$body.append($("<div>").text(d("The deputy has the following permissions")),$('<div class="select-container">').append($('<label for="inbox-deputy-selector">').text(p.mail),new n.SelectView({id:"inbox-deputy-selector",name:"permission",model:t,list:[{value:c.none,label:d("None")},{value:c.viewer,label:d("Viewer (read emails)")},{value:c.editor,label:d("Editor (create/edit emails)")},{value:c.author,label:d("Author (create/edit/delete emails)")}]}).render().$el),new n.CustomCheckboxView({id:"send-on-behalf-checkbox",name:"sendOnBehalfOf",label:d("Deputy can send emails on your behalf"),model:o}).render().$el,$('<div class="select-container">').append($('<label for="calendar-deputy-selector">').text(p.calendar),new n.SelectView({id:"calendar-deputy-selector",name:"permission",model:e,list:[{value:c.none,label:d("None")},{value:c.viewer,label:d("Viewer (view appointments)")},{value:c.editor,label:d("Editor (create/edit appointments)")},{value:c.author,label:d("Author (create/edit/delete appointments)")}]}).render().$el)).addClass("deputy-permissions-dialog")});o.get("deputyId")&&t.addButton({className:"btn-default pull-left",label:d("Remove"),action:"remove"}),t.addCancelButton().addButton({className:"btn-primary",label:d("Save"),action:"save"}).on("cancel",function(){void 0!==o.get("deputyId")?o.set(e):o.collection.remove(o)}).on("save",function(){o.collection.trigger("reset"),void 0!==o.get("deputyId")?s.update(o).fail(function(){u("error",d("Could not update deputy permissions.")),o.set(e)}):s.create(o).then(function(e){o.set("deputyId",e.deputyId)},function(){u("error",d("Could not create deputy.")),o.collection.remove(o)})}).on("remove",function(){b(o)}).open()}function b(e){new i({title:d("Remove deputy %1$s",l.getFullName(e.get("userData").attributes,!1))}).build(function(){this.$body.append($("<div>").text(d("Do you want to remove %1$s from your deputy list?",l.getFullName(e.get("userData").attributes,!1))))}).addCancelButton().addButton({className:"btn-primary",label:d("Remove"),action:"remove"}).on("remove",function(){s.remove(e).then(function(){e.collection.remove(e)},function(){u("error",d("Could not remove deputy."))})}).open()}var g=e.extend({events:{"click .remove":"removeDeputy","click .edit":"showPermissions"},tagName:"ul",className:"flex deputy-list-view list-unstyled",initialize:function(e){e=e||{},this.collection=new Backbone.Collection(e.deputies),this.collection.on("add reset remove",this.render.bind(this))},render:function(){return this.$el.attr("role","list").empty(),0===this.collection.length&&this.$el.append($('<li class="flex empty-message" role="listitem">').append(d("You have currently no deputies assigned.")+"<br/>"+d("Deputies can get acces to your Inbox and Calendar."))),this.collection.each(this.renderDeputy.bind(this)),this},renderDeputy:function(e){var t,i,o=e.get("userData"),n=l.getFullName(o.attributes,!0),a=l.getInitials(o.attributes),s=o.get("image1_url")?$('<i class="user-picture" aria-hidden="true">').css("background-image","url("+l.getImage(o.attributes)+")"):$('<div class="user-picture initials" aria-hidden="true">').text(a);this.$el.append($('<li class="flex" role="listitem">').attr("data-id",o.get("id")).append($('<div class="flex-item">').append(s,$('<div class="data-container">').append($('<div class="name">').append(n),$('<div class="permissions">').text((t=e,i=_(t.get("modulePermissions")).map(function(e,t){return d("%1$s (%2$s)",p[t],f[e.permission])}),t.get("sendOnBehalfOf")&&i.unshift(d("Allowed to send emails on your behalf")),i.join(", "))))),$('<div class="flex-item">').append($('<button class="btn btn-link edit">').attr("data-cid",e.cid).text(d("Edit")),$('<button class="btn btn-link remove flex">').attr({"aria-label":d("Remove"),"data-cid":e.cid}).append($.icon("fa-trash",d("Remove"))))))},removeDeputy:function(e){e.stopPropagation();var t=this.collection.get(e.currentTarget.getAttribute("data-cid"));t&&b(t)},showPermissions:function(e){var t=this.collection.get(e.currentTarget.getAttribute("data-cid"));t&&v(t)}}),y=Backbone.Collection.extend({modelId:function(e){return e.user_id||e.id}});return{open:function(){new i({point:"io.ox/core/deputy/dialog",title:d("Manage deputies"),width:640}).build(function(){var o=this,n=new y;this.$body.addClass("deputy-dialog-body").busy(),s.getAll().then(function(i){var e=_(i).map(function(t){return t.modulePermissions||(t.modulePermissions={}),t.modulePermissions.mail||(t.modulePermissions.mail={permission:c.none,folderIds:[a.getDefaultFolder("mail")]}),t.modulePermissions.calendar||(t.modulePermissions.calendar={permission:c.none,folderIds:[a.getDefaultFolder("calendar")]}),r.get({id:t.userId}).then(function(e){n.add(e),t.userData=n.get(e)},function(e){console.warn("Error while getting deputy user data!",t,e),i=_(i).reject(function(e){return e.deputyId===t.deputyId})})});$.when.apply($,e).always(function(){o.$body.idle(),o.$el.removeClass("compact"),o.deputyListView=new g({deputies:i}),o.$body.append(new t({apiOptions:{users:!0},placeholder:d("Add people"),collection:n,scrollIntoView:!0,useGABOnly:!0,selection:{behavior:"single"}}).render().$el,o.deputyListView.render().$el),o.$body.find("input.add-participant").focus(),n.on("add",function(e){var t,i=e.get("user_id")||e.get("id");i&&i!==ox.user_id?(t=_.extend({},m,{userId:i,userData:e}),v(o.deputyListView.collection.add(t))):n.remove(e,{silent:!0})}),o.deputyListView.collection.on("remove",function(e){n.remove(e.get("userId"))})})},function(e){console.error(e),u("error",d("Could not load deputy data.")),o.close()})}).addButton({className:"btn-primary",label:d("Close"),action:"cancel"}).open()}}});